//+------------------------------------------------------------------+
//|                                                      ProjectName |
//|                                      Copyright 2011, CompanyName |
//|                                       http://www.companyname.net |
//+------------------------------------------------------------------+
/*
        SmoothAlgorithms.mqh
       (): MetaTrader\\MQL5\Include
 */
//+------------------------------------------------------------------+
//|                                                      XRSX_BB.mq5 | 
//|                             Copyright  2011,   Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Nikolay Kositsin"
#property link "farria@mail.redcom.ru"
#property description "Relative Strength Index"
//---   
#property version   "1.00"
//---     
#property indicator_separate_window
//---   
#property indicator_buffers 9 
//---    
#property indicator_plots   7
//+-----------------------------------+
//|     1 |
//+-----------------------------------+
//---      
#property indicator_type1   DRAW_COLOR_HISTOGRAM
//---     
#property indicator_color1 Gray,Green,Blue,Red,Magenta
//---   -  
#property indicator_style1  STYLE_SOLID
//---     3
#property indicator_width1  3
//---   
#property indicator_label1  "XRSX"
//+-----------------------------------+
//|     2 |
//+-----------------------------------+
//---      
#property indicator_type2   DRAW_COLOR_LINE
//---      
#property indicator_color2 Gray,Lime,DarkOrange
//---   - 
#property indicator_style2  STYLE_DASH
//---     2
#property indicator_width2  2
//---   
#property indicator_label2  "Signal line"
//+--------------------------------------------+
//|     BB  |
//+--------------------------------------------+
//---      
#property indicator_type3   DRAW_LINE
#property indicator_type4   DRAW_LINE
#property indicator_type5   DRAW_LINE
#property indicator_type6   DRAW_LINE
#property indicator_type7   DRAW_LINE
//---    
#property indicator_color3  Blue
#property indicator_color4  Red
#property indicator_color5  Gray
#property indicator_color6  Red
#property indicator_color7  Blue
//---   -  
#property indicator_style3 STYLE_DASHDOTDOT
#property indicator_style4 STYLE_DASHDOTDOT
#property indicator_style5 STYLE_DASHDOTDOT
#property indicator_style6 STYLE_DASHDOTDOT
#property indicator_style7 STYLE_DASHDOTDOT
//---     1
#property indicator_width3  1
#property indicator_width4  1
#property indicator_width5  1
#property indicator_width6  1
#property indicator_width7  1
//---    
#property indicator_label3  "+2Sigma"
#property indicator_label4  "+Sigma"
#property indicator_label5  "Middle"
#property indicator_label6  "-Sigma"
#property indicator_label7  "-2Sigma"
//+-------------------------------------------+
//|      |
//+-------------------------------------------+
#include <SmoothAlgorithms.mqh>
//+-----------------------------------+
//---    CXMA  CStdDeviation   SmoothAlgorithms.mqh
CXMA UPXRSX,DNXRSX,XSIGN,XMA;
CStdDeviation STD;
//+-----------------------------------+
//|             |
//+-----------------------------------+
enum Applied_price_      // 
  {
   PRICE_CLOSE_ = 1,     //Close
   PRICE_OPEN_,          //Open
   PRICE_HIGH_,          //High
   PRICE_LOW_,           //Low
   PRICE_MEDIAN_,        //Median Price (HL/2)
   PRICE_TYPICAL_,       //Typical Price (HLC/3)
   PRICE_WEIGHTED_,      //Weighted Close (HLCC/4)
   PRICE_SIMPL_,         //Simple Price (OC/2)
   PRICE_QUARTER_,       //Quarted Price (HLOC/4) 
   PRICE_TRENDFOLLOW0_,  //TrendFollow_1 Price 
   PRICE_TRENDFOLLOW1_   //TrendFollow_2 Price 
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
enum IndStyle //  
  {
   COLOR_LINE = DRAW_COLOR_LINE,          // 
   COLOR_HISTOGRAM=DRAW_COLOR_HISTOGRAM,  // 
   COLOR_ARROW=DRAW_COLOR_ARROW           // 
  };
//+-----------------------------------+
//|         |
//+-----------------------------------+
input Smooth_Method DSmoothMethod=MODE_JurX; //   
input int DPeriod=15;                        //  
input int DPhase=100;                        //   
//--- DPhase:  JJMA    -100 ... +100,     ;
//--- DPhase:  VIDIA   CMO,  AMA    
input Smooth_Method SSmoothMethod=MODE_JJMA; //    
input int SPeriod=7;                         //   
input int SPhase=100;                        //   
//--- SPhase:  JJMA    -100 ... +100,     ;
//--- SPhase:  VIDIA   CMO,  AMA    
input Applied_price_ IPC=PRICE_CLOSE;        //  
input int Shift=0;                           //      
input IndStyle Style=COLOR_HISTOGRAM;        //   XRSX
input int BBPeriod=100;                      //    
input double BBDeviation1 = 1.0;             //   
input double BBDeviation2 = 1.6;             //   
//+-----------------------------------+
//---   ,   
//---      
double XRSX[],XXRSX[];
double ColorXRSX[],ColorXXRSX[];
double ExtLineBuffer1[],ExtLineBuffer2[],ExtLineBuffer3[],ExtLineBuffer4[],ExtLineBuffer5[];
//---     
double quotient;
//---      
int StartBars,StartBarsD,StartBarsS,StartBarsB;
//+------------------------------------------------------------------+   
//| XRSX indicator initialization function                           | 
//+------------------------------------------------------------------+ 
void OnInit()
  {
//---     
   StartBarsD=UPXRSX.GetStartBars(DSmoothMethod,DPeriod,DPhase)+1;
   StartBarsS=StartBarsD+UPXRSX.GetStartBars(SSmoothMethod,SPeriod,SPhase);
   StartBarsB=StartBarsD+BBPeriod;
   StartBars=MathMax(StartBarsS,StartBarsB);
//---       
   UPXRSX.XMALengthCheck("DPeriod", DPeriod);
   UPXRSX.XMALengthCheck("SPeriod", SPeriod);
//---       
   UPXRSX.XMAPhaseCheck("DPhase",DPhase,DSmoothMethod);
   UPXRSX.XMAPhaseCheck("SPhase",SPhase,SSmoothMethod);
//---     
   quotient=BBDeviation2/BBDeviation1;
//---      
   SetIndexBuffer(0,XRSX,INDICATOR_DATA);
//---    1  
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//---      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,StartBarsD+1);
//---   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//---       
   PlotIndexSetInteger(0,PLOT_DRAW_TYPE,Style);
//---          
   SetIndexBuffer(1,ColorXRSX,INDICATOR_COLOR_INDEX);
//---      
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,StartBarsD+1);
//---      
   SetIndexBuffer(2,XXRSX,INDICATOR_DATA);
//---    2  
   PlotIndexSetInteger(2,PLOT_SHIFT,Shift);
//---      
   PlotIndexSetInteger(2,PLOT_DRAW_BEGIN,StartBarsS+1);
//---   ,      
   PlotIndexSetDouble(2,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//---          
   SetIndexBuffer(3,ColorXXRSX,INDICATOR_COLOR_INDEX);
//---      
   PlotIndexSetInteger(3,PLOT_DRAW_BEGIN,StartBarsS+1);
//---      
   SetIndexBuffer(4,ExtLineBuffer1,INDICATOR_DATA);
   SetIndexBuffer(5,ExtLineBuffer2,INDICATOR_DATA);
   SetIndexBuffer(6,ExtLineBuffer3,INDICATOR_DATA);
   SetIndexBuffer(7,ExtLineBuffer4,INDICATOR_DATA);
   SetIndexBuffer(8,ExtLineBuffer5,INDICATOR_DATA);
//---  ,      
   PlotIndexSetInteger(4,PLOT_DRAW_BEGIN,StartBarsB);
   PlotIndexSetInteger(5,PLOT_DRAW_BEGIN,StartBarsB);
   PlotIndexSetInteger(6,PLOT_DRAW_BEGIN,StartBarsB);
   PlotIndexSetInteger(7,PLOT_DRAW_BEGIN,StartBarsB);
   PlotIndexSetInteger(8,PLOT_DRAW_BEGIN,StartBarsB);
//---      
   PlotIndexSetDouble(4,PLOT_EMPTY_VALUE,EMPTY_VALUE);
   PlotIndexSetDouble(5,PLOT_EMPTY_VALUE,EMPTY_VALUE);
   PlotIndexSetDouble(6,PLOT_EMPTY_VALUE,EMPTY_VALUE);
   PlotIndexSetDouble(7,PLOT_EMPTY_VALUE,EMPTY_VALUE);
   PlotIndexSetDouble(8,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//---      
   string shortname,Smooth;
   Smooth=UPXRSX.GetString_MA_Method(DSmoothMethod);
   StringConcatenate(shortname,"Relative Strength Index(",string(DPeriod),",",Smooth,")");
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,0);
//---  
  }
//+------------------------------------------------------------------+ 
//| XRSX iteration function                                          | 
//+------------------------------------------------------------------+ 
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---       
   if(rates_total<StartBars) return(0);
//---       
   double dprice_,absdprice_,up_xrsx,dn_xrsx,xrsx,xxrsx,xma,stdev1,stdev2;
//---        
   int first1,first2,first3,bar;
//---    first    
   if(prev_calculated>rates_total || prev_calculated<=0) //      
     {
      first1=1; //      
      first2=StartBarsD+1;
      first3=StartBarsS+1;
     }
   else
     {
      first1=prev_calculated-1; //      
      first2=first1;
      first3=first1;
     }
//---    
   for(bar=first1; bar<rates_total; bar++)
     {
      //---   PriceSeries      dprice_
      dprice_=PriceSeries(IPC,bar,open,low,high,close)-PriceSeries(IPC,bar-1,open,low,high,close);
      absdprice_=MathAbs(dprice_);
      //---    XMASeries
      up_xrsx = UPXRSX.XMASeries(1,prev_calculated,rates_total,DSmoothMethod,DPhase,DPeriod,   dprice_,bar,false);
      dn_xrsx = DNXRSX.XMASeries(1,prev_calculated,rates_total,DSmoothMethod,DPhase,DPeriod,absdprice_,bar,false);
      //---       
      if(dn_xrsx==0) xrsx=EMPTY_VALUE;
      else
        {
         xrsx=up_xrsx/dn_xrsx;
         //---      
         if(xrsx > +1)xrsx = +1;
         if(xrsx < -1)xrsx = -1;
        }
      //---      
      XRSX[bar]=xrsx*100;
      //---   
      xxrsx=XSIGN.XMASeries(StartBarsD,prev_calculated,rates_total,SSmoothMethod,SPhase,SPeriod,XRSX[bar],bar,false);
      //---      
      XXRSX[bar]=xxrsx;
      //---   
      xma=XMA.XMASeries(StartBarsD+1,prev_calculated,rates_total,MODE_SMA_,0,BBPeriod,XRSX[bar],bar,false);
      stdev1=STD.StdDevSeries(StartBarsB,prev_calculated,rates_total,BBPeriod,BBDeviation1,XRSX[bar],xma,bar,false);
      stdev2=stdev1*quotient;
      //--- 
      if(bar<=StartBarsB+BBPeriod)
        {
         xma=EMPTY_VALUE;
         stdev1=0.0;
         stdev2=0.0;
        }
      ExtLineBuffer1[bar]=xma+stdev2;
      ExtLineBuffer2[bar]=xma+stdev1;
      ExtLineBuffer3[bar]=xma;
      ExtLineBuffer4[bar]=xma-stdev1;
      ExtLineBuffer5[bar]=xma-stdev2;
     }
//---     XRSX
   for(bar=first2; bar<rates_total; bar++)
     {
      ColorXRSX[bar]=0;
      if(XRSX[bar]>0)
        {
         if(XRSX[bar]>XRSX[bar-1]) ColorXRSX[bar]=1;
         if(XRSX[bar]<XRSX[bar-1]) ColorXRSX[bar]=2;
        }
      if(XRSX[bar]<0)
        {
         if(XRSX[bar]<XRSX[bar-1]) ColorXRSX[bar]=3;
         if(XRSX[bar]>XRSX[bar-1]) ColorXRSX[bar]=4;
        }
     }
//---     
   for(bar=first3; bar<rates_total; bar++)
     {
      ColorXXRSX[bar]=0;
      if(XRSX[bar]>XXRSX[bar-1]) ColorXXRSX[bar]=1;
      if(XRSX[bar]<XXRSX[bar-1]) ColorXXRSX[bar]=2;
     }
//---
   return(rates_total);
  }
//+------------------------------------------------------------------+
